<?php
/**
 * This file is a part of the miniorange-saml-20-single-sign-on plugin.
 *
 * @link https://plugins.miniorange.com/
 * @author miniOrange
 * @package miniorange-saml-20-single-sign-on
 */


use RobRichards\XMLSecLibs\XMLSecurityKey;
use RobRichards\XMLSecLibs\XMLSecurityDSig;
use RobRichards\XMLSecLibs\XMLSecEnc;
class SAML2SPAssertion
{
    private $id;
    private $issueInstant;
    private $issuer;
    private $nameId;
    private $encryptedNameId;
    private $encryptedAttribute;
    private $encryptionKey;
    private $notBefore;
    private $notOnOrAfter;
    private $validAudiences;
    private $sessionNotOnOrAfter;
    private $sessionIndex;
    private $authnInstant;
    private $authnContextClassRef;
    private $authnContextDecl;
    private $authnContextDeclRef;
    private $AuthenticatingAuthority;
    private $attributes;
    private $nameFormat;
    private $signatureKey;
    private $certificates;
    private $signatureData;
    private $requiredEncAttributes;
    private $SubjectConfirmation;
    private $privateKeyUrl;
    protected $wasSignedAtConstruction = FALSE;
    public function __construct(DOMElement $ER = NULL, $kk)
    {
        $this->id = SAMLSPUtilities::generateId();
        $this->issueInstant = SAMLSPUtilities::generateTimestamp();
        $this->issuer = '';
        $this->authnInstant = SAMLSPUtilities::generateTimestamp();
        $this->attributes = array();
        $this->nameFormat = "\165\162\156\x3a\x6f\x61\163\x69\x73\x3a\156\141\x6d\x65\163\x3a\164\143\x3a\123\x41\115\x4c\72\61\x2e\x31\x3a\x6e\141\x6d\145\151\x64\55\x66\x6f\162\155\x61\x74\x3a\165\x6e\163\x70\x65\x63\x69\x66\x69\145\144";
        $this->certificates = array();
        $this->AuthenticatingAuthority = array();
        $this->SubjectConfirmation = array();
        if (!($ER === NULL)) {
            goto W4;
        }
        return;
        W4:
        if (!($ER->localName === "\105\x6e\143\162\171\x70\x74\x65\144\101\x73\163\145\x72\x74\x69\x6f\156")) {
            goto Gv;
        }
        $xN = SAMLSPUtilities::xpQuery($ER, "\56\x2f\x78\x65\x6e\143\x3a\105\156\143\x72\x79\x70\164\x65\x64\104\x61\x74\141");
        $eF = SAMLSPUtilities::xpQuery($ER, "\57\57\x2a\133\x6c\x6f\x63\141\x6c\55\156\x61\155\x65\x28\51\75\47\105\x6e\x63\162\x79\160\x74\x65\144\x4b\145\x79\x27\x5d\x2f\x2a\x5b\154\x6f\x63\x61\154\55\156\x61\x6d\145\x28\x29\x3d\x27\x45\x6e\143\x72\x79\160\x74\151\x6f\x6e\x4d\x65\164\150\157\144\47\135\57\x40\x41\x6c\147\157\162\151\164\150\x6d");
        $fe = $eF[0]->value;
        $Ts = SAMLSPUtilities::getEncryptionAlgorithm($fe);
        if (count($xN) === 0) {
            goto MW;
        }
        if (count($xN) > 1) {
            goto KD;
        }
        goto MF;
        MW:
        throw new Exception("\115\x69\x73\163\151\156\147\40\145\156\143\x72\x79\x70\164\145\144\x20\144\141\x74\x61\x20\151\x6e\40\74\x73\x61\155\154\72\105\x6e\x63\x72\171\x70\164\145\144\x41\163\163\x65\x72\x74\x69\157\156\76\x2e");
        goto MF;
        KD:
        throw new Exception("\x4d\157\162\x65\x20\164\x68\x61\156\x20\x6f\156\x65\40\x65\156\x63\x72\171\x70\164\x65\144\x20\144\x61\x74\141\40\145\x6c\x65\155\145\x6e\164\40\151\156\40\74\163\x61\x6d\x6c\x3a\x45\x6e\143\162\x79\x70\164\145\x64\x41\163\x73\145\x72\164\151\157\156\76\56");
        MF:
        $Xx = new XMLSecurityKey($Ts, array("\164\x79\x70\x65" => "\160\162\151\166\141\164\x65"));
        $Xx->loadKey($kk, FALSE);
        $TJ = array();
        $ER = SAMLSPUtilities::decryptElement($xN[0], $Xx, $TJ);
        Gv:
        if ($ER->hasAttribute("\x49\104")) {
            goto rH;
        }
        throw new Exception("\x4d\151\163\x73\x69\156\x67\40\111\x44\x20\141\x74\164\x72\151\142\165\164\x65\40\x6f\156\x20\x53\101\115\114\40\141\163\x73\x65\162\x74\x69\157\156\56");
        rH:
        $this->id = $ER->getAttribute("\x49\x44");
        if (!($ER->getAttribute("\x56\145\x72\x73\151\157\156") !== "\x32\x2e\60")) {
            goto yo;
        }
        throw new Exception("\125\x6e\163\x75\x70\x70\x6f\x72\164\x65\x64\x20\x76\x65\162\163\x69\x6f\x6e\x3a\x20" . $ER->getAttribute("\126\x65\x72\163\x69\157\156"));
        yo:
        $this->issueInstant = SAMLSPUtilities::xsDateTimeToTimestamp($ER->getAttribute("\111\163\163\165\145\111\156\x73\x74\x61\156\x74"));
        $CL = SAMLSPUtilities::xpQuery($ER, "\x2e\x2f\x73\x61\x6d\x6c\137\x61\163\163\x65\162\164\x69\x6f\x6e\x3a\111\x73\163\165\x65\162");
        if (!empty($CL)) {
            goto vC;
        }
        throw new Exception("\115\151\x73\x73\151\x6e\x67\40\x3c\163\x61\x6d\x6c\72\x49\163\163\x75\x65\162\76\40\x69\x6e\40\x61\x73\x73\x65\162\x74\x69\x6f\x6e\56");
        vC:
        $this->issuer = trim($CL[0]->textContent);
        $this->parseConditions($ER);
        $this->parseAuthnStatement($ER);
        $this->parseAttributes($ER);
        $this->parseEncryptedAttributes($ER);
        $this->parseSignature($ER);
        $this->parseSubject($ER);
    }
    private function parseSubject(DOMElement $ER)
    {
        $jR = SAMLSPUtilities::xpQuery($ER, "\x2e\57\x73\141\x6d\154\x5f\x61\163\163\x65\x72\x74\x69\x6f\156\72\123\x75\142\152\x65\x63\164");
        if (empty($jR)) {
            goto W5;
        }
        if (count($jR) > 1) {
            goto f2;
        }
        goto Q_;
        W5:
        return;
        goto Q_;
        f2:
        throw new Exception("\x4d\x6f\x72\x65\x20\164\150\141\x6e\40\157\x6e\145\40\x3c\x73\141\155\x6c\72\x53\x75\x62\x6a\x65\143\x74\76\40\x69\156\40\74\x73\141\155\x6c\72\x41\x73\x73\145\162\164\151\157\156\76\x2e");
        Q_:
        $jR = $jR[0];
        $uO = SAMLSPUtilities::xpQuery($jR, "\x2e\x2f\163\x61\155\x6c\x5f\x61\163\x73\x65\162\164\x69\x6f\156\x3a\x4e\141\x6d\145\x49\104\x20\x7c\x20\x2e\57\x73\x61\x6d\x6c\137\141\x73\x73\x65\x72\164\151\157\x6e\72\x45\x6e\143\x72\x79\160\x74\145\x64\111\104\x2f\170\x65\156\143\72\105\156\x63\x72\x79\x70\164\145\x64\x44\x61\164\141");
        if (empty($uO)) {
            goto lB;
        }
        if (count($uO) > 1) {
            goto Oj;
        }
        goto ho;
        lB:
        $xF = $_POST["\x52\x65\154\x61\x79\x53\164\x61\x74\145"];
        if ($xF == "\x74\x65\x73\164\x56\x61\154\151\144\x61\x74\x65" or $xF == "\164\145\x73\164\116\145\x77\x43\145\x72\x74\x69\x66\151\x63\141\164\x65") {
            goto kD;
        }
        wp_die("\127\145\40\x63\157\x75\x6c\144\40\x6e\x6f\x74\40\x73\151\x67\156\x20\171\x6f\165\x20\x69\x6e\x2e\x20\120\x6c\145\141\x73\145\x20\143\157\156\x74\141\x63\164\40\171\x6f\165\162\40\x61\x64\155\x69\156\x69\163\x74\x72\141\164\x6f\162");
        goto CS;
        kD:
        echo "\74\x64\151\166\x20\x73\x74\x79\x6c\x65\75\x22\146\x6f\156\164\55\x66\141\155\x69\154\x79\x3a\103\141\154\x69\x62\162\151\73\x70\x61\144\144\x69\x6e\147\72\60\x20\x33\x25\x3b\x22\x3e";
        echo "\x3c\x64\x69\x76\x20\163\164\171\x6c\x65\x3d\x22\x63\157\x6c\157\x72\x3a\40\43\x61\x39\x34\64\x34\62\x3b\142\x61\x63\153\x67\162\157\165\156\144\x2d\x63\157\x6c\157\x72\72\40\x23\x66\62\144\x65\x64\145\x3b\x70\x61\144\144\151\156\x67\x3a\40\x31\x35\160\x78\73\155\x61\x72\147\x69\156\55\x62\x6f\164\x74\157\155\72\40\x32\60\160\170\73\x74\145\170\164\x2d\141\154\151\x67\x6e\x3a\143\x65\x6e\164\145\162\x3b\x62\157\162\x64\x65\162\72\x31\160\x78\x20\163\x6f\154\x69\144\40\43\x45\x36\x42\x33\102\x32\73\x66\157\156\x74\x2d\163\x69\172\145\72\x31\x38\x70\x74\x3b\x22\x3e\x20\x45\x52\122\x4f\x52\74\57\144\151\166\x3e\12\40\x20\40\40\40\x20\40\x20\x20\40\40\x3c\x64\x69\x76\40\x73\x74\x79\x6c\x65\75\x22\x63\157\x6c\157\x72\72\40\x23\x61\71\x34\x34\64\62\x3b\146\157\x6e\x74\x2d\x73\151\172\x65\72\x31\x34\x70\164\73\40\155\141\162\x67\151\156\x2d\x62\157\164\164\157\155\x3a\62\60\x70\170\x3b\x22\x3e\74\x70\x3e\x3c\x73\x74\x72\157\x6e\x67\x3e\105\x72\162\x6f\162\x3a\x20\74\x2f\163\164\x72\157\x6e\x67\76\115\151\x73\x73\151\156\147\40\40\116\x61\x6d\x65\111\104\x20\157\162\x20\105\x6e\143\x72\171\x70\164\145\x64\111\104\40\x69\x6e\x20\123\101\115\114\40\x52\145\x73\160\157\156\x73\x65\56\74\57\160\76\12\40\x20\40\40\x20\x20\40\40\x20\x20\x20\40\40\40\40\x20\74\x70\x3e\x50\x6c\x65\141\163\x65\40\143\157\156\x74\x61\x63\x74\40\171\x6f\165\162\40\x61\144\x6d\151\156\x69\163\x74\162\x61\164\x6f\x72\x20\141\x6e\x64\40\x72\x65\x70\x6f\162\x74\x20\164\x68\145\x20\x66\x6f\154\x6c\x6f\167\151\156\x67\x20\x65\x72\162\157\162\x3a\74\57\x70\76\12\x20\x20\40\40\x20\x20\40\x20\x20\40\40\x20\40\x20\x20\40\x3c\160\x3e\x3c\163\x74\162\x6f\156\x67\x3e\120\x6f\163\163\x69\x62\154\145\40\x43\141\165\x73\145\x3a\74\x2f\x73\x74\162\157\x6e\x67\76\40\x4e\141\x6d\x65\111\104\x20\156\x6f\x74\40\146\x6f\165\156\144\40\151\156\40\x53\101\115\x4c\40\122\x65\163\x70\x6f\156\x73\145\40\163\165\x62\152\x65\x63\x74\x2e\74\x2f\x70\76\xa\40\x20\x20\x20\x20\40\x20\40\40\x20\40\x20\40\40\40\40\x3c\x2f\x64\x69\166\x3e\12\40\40\x20\40\x20\x20\x20\x20\40\40\40\40\x20\40\x20\x20\74\144\151\x76\40\x73\164\171\154\145\x3d\x22\155\141\162\x67\151\x6e\72\x33\x25\73\144\151\163\x70\x6c\141\x79\x3a\x62\x6c\x6f\143\x6b\73\164\145\170\164\x2d\141\x6c\x69\x67\156\72\143\145\x6e\x74\145\x72\x3b\42\76\xa\x20\x20\40\x20\40\x20\x20\40\40\x20\40\x20\40\x20\x20\40\x3c\x64\151\x76\40\163\164\171\x6c\x65\x3d\x22\155\x61\162\147\151\156\72\x33\45\x3b\144\x69\x73\x70\x6c\x61\x79\x3a\142\x6c\x6f\x63\153\x3b\x74\x65\170\164\55\x61\x6c\151\x67\156\x3a\143\145\x6e\164\145\x72\73\x22\76\74\151\x6e\x70\165\x74\40\x73\164\x79\x6c\x65\x3d\x22\160\141\144\144\x69\156\147\72\x31\x25\73\x77\151\x64\x74\x68\72\x31\x30\60\x70\x78\x3b\x62\x61\143\x6b\x67\x72\157\x75\x6e\x64\72\40\43\60\60\71\x31\x43\x44\40\x6e\157\156\145\40\x72\x65\160\x65\x61\x74\40\163\x63\162\x6f\x6c\x6c\40\60\x25\40\x30\45\x3b\143\x75\162\x73\x6f\x72\72\x20\x70\x6f\x69\x6e\x74\145\x72\x3b\x66\x6f\156\164\x2d\163\151\172\145\x3a\61\65\160\x78\x3b\x62\x6f\x72\x64\145\x72\x2d\x77\151\144\x74\x68\x3a\40\x31\x70\x78\x3b\x62\157\162\144\x65\162\55\x73\x74\171\x6c\x65\72\x20\163\157\x6c\x69\144\73\142\157\162\x64\x65\162\55\x72\x61\144\x69\x75\x73\72\40\x33\160\x78\x3b\167\x68\151\164\145\x2d\163\x70\141\143\x65\72\40\156\157\x77\162\141\160\73\x62\157\170\x2d\x73\x69\x7a\151\x6e\147\72\40\x62\x6f\162\144\145\x72\55\142\x6f\x78\73\142\157\162\x64\145\162\x2d\143\157\x6c\x6f\162\x3a\x20\43\x30\60\x37\63\x41\x41\73\142\x6f\170\x2d\163\150\x61\144\157\167\x3a\40\x30\160\x78\x20\x31\160\x78\40\60\x70\170\40\162\x67\x62\x61\x28\x31\62\x30\x2c\40\62\x30\60\54\x20\x32\63\x30\x2c\x20\60\56\x36\x29\x20\151\156\x73\145\164\x3b\143\x6f\154\x6f\x72\72\40\x23\x46\x46\x46\x3b\x22\164\171\x70\x65\75\x22\x62\x75\x74\164\x6f\x6e\42\40\x76\x61\154\x75\x65\x3d\42\x44\157\x6e\145\x22\40\157\x6e\103\154\x69\143\x6b\x3d\42\163\x65\x6c\146\56\x63\x6c\x6f\163\x65\x28\51\73\x22\x3e\x3c\x2f\x64\151\166\x3e";
        exit;
        CS:
        goto ho;
        Oj:
        throw new Exception("\x4d\157\162\x65\x20\x74\150\141\x6e\x20\x6f\x6e\145\40\74\163\141\x6d\x6c\72\x4e\141\x6d\145\x49\104\76\40\x6f\162\40\74\x73\141\x6d\154\72\105\x6e\143\162\x79\x70\164\145\x64\x44\x3e\40\x69\x6e\x20\74\163\141\155\154\72\x53\x75\x62\x6a\x65\143\164\76\x2e");
        ho:
        $uO = $uO[0];
        if ($uO->localName === "\105\156\x63\x72\x79\160\164\x65\x64\x44\141\164\x61") {
            goto od;
        }
        $this->nameId = SAMLSPUtilities::parseNameId($uO);
        goto l3;
        od:
        $this->encryptedNameId = $uO;
        l3:
    }
    private function parseConditions(DOMElement $ER)
    {
        $T4 = SAMLSPUtilities::xpQuery($ER, "\x2e\x2f\x73\x61\x6d\x6c\137\x61\163\163\x65\x72\164\x69\157\156\72\x43\x6f\x6e\x64\151\x74\x69\157\x6e\163");
        if (empty($T4)) {
            goto tH;
        }
        if (count($T4) > 1) {
            goto bc;
        }
        goto GX;
        tH:
        return;
        goto GX;
        bc:
        throw new Exception("\115\x6f\162\x65\x20\x74\x68\x61\156\x20\x6f\x6e\145\x20\74\x73\141\155\154\x3a\103\157\x6e\144\151\x74\x69\157\x6e\163\76\40\x69\156\40\74\163\141\155\x6c\x3a\x41\163\x73\145\162\164\151\x6f\156\76\x2e");
        GX:
        $T4 = $T4[0];
        if (!$T4->hasAttribute("\116\157\164\x42\145\x66\157\x72\145")) {
            goto DV;
        }
        $Hr = SAMLSPUtilities::xsDateTimeToTimestamp($T4->getAttribute("\116\157\164\102\x65\146\157\162\x65"));
        if (!($this->notBefore === NULL || $this->notBefore < $Hr)) {
            goto XF;
        }
        $this->notBefore = $Hr;
        XF:
        DV:
        if (!$T4->hasAttribute("\116\157\164\x4f\156\x4f\x72\101\146\164\x65\162")) {
            goto Q6;
        }
        $H0 = SAMLSPUtilities::xsDateTimeToTimestamp($T4->getAttribute("\x4e\157\164\x4f\x6e\x4f\x72\101\x66\x74\145\162"));
        if (!($this->notOnOrAfter === NULL || $this->notOnOrAfter > $H0)) {
            goto Gc;
        }
        $this->notOnOrAfter = $H0;
        Gc:
        Q6:
        $Bt = $T4->firstChild;
        GY:
        if (!($Bt !== NULL)) {
            goto Oa;
        }
        if (!$Bt instanceof DOMText) {
            goto x_;
        }
        goto FL;
        x_:
        if (!($Bt->namespaceURI !== "\165\x72\156\x3a\157\141\x73\x69\163\x3a\156\141\155\145\x73\72\x74\x63\72\123\101\x4d\114\x3a\x32\x2e\60\x3a\x61\x73\x73\x65\x72\x74\x69\x6f\156")) {
            goto xa;
        }
        throw new Exception("\x55\156\153\x6e\x6f\x77\156\40\156\x61\x6d\x65\x73\x70\x61\x63\x65\40\x6f\146\40\x63\x6f\x6e\x64\151\x74\x69\x6f\156\x3a\40" . var_export($Bt->namespaceURI, TRUE));
        xa:
        switch ($Bt->localName) {
            case "\101\x75\144\x69\x65\x6e\143\x65\x52\x65\x73\x74\162\151\143\x74\x69\157\x6e":
                $yP = SAMLSPUtilities::extractStrings($Bt, "\165\162\x6e\x3a\x6f\141\x73\151\163\x3a\156\x61\155\145\163\72\x74\x63\72\x53\x41\x4d\x4c\x3a\62\x2e\60\72\x61\x73\x73\x65\x72\x74\x69\157\x6e", "\101\165\144\151\x65\156\143\x65");
                if ($this->validAudiences === NULL) {
                    goto E7;
                }
                $this->validAudiences = array_intersect($this->validAudiences, $yP);
                goto lT;
                E7:
                $this->validAudiences = $yP;
                lT:
                goto PX;
            case "\x4f\156\x65\x54\151\155\145\125\163\145":
                goto PX;
            case "\x50\162\x6f\170\171\122\x65\x73\164\x72\x69\143\x74\151\x6f\x6e":
                goto PX;
            default:
                throw new Exception("\x55\x6e\153\156\157\167\156\x20\x63\x6f\x6e\144\x69\164\x69\157\x6e\72\40" . var_export($Bt->localName, TRUE));
        }
        Es:
        PX:
        FL:
        $Bt = $Bt->nextSibling;
        goto GY;
        Oa:
    }
    private function parseAuthnStatement(DOMElement $ER)
    {
        $HP = SAMLSPUtilities::xpQuery($ER, "\56\x2f\163\141\x6d\154\x5f\x61\163\163\145\x72\164\151\157\x6e\x3a\101\165\164\150\156\123\x74\x61\x74\x65\155\x65\x6e\164");
        if (empty($HP)) {
            goto RU;
        }
        if (count($HP) > 1) {
            goto yj;
        }
        goto cw;
        RU:
        $this->authnInstant = NULL;
        return;
        goto cw;
        yj:
        throw new Exception("\115\157\x72\x65\40\x74\x68\141\164\40\157\156\x65\40\x3c\163\x61\x6d\154\72\x41\165\x74\150\156\123\164\x61\x74\145\155\x65\156\164\76\40\151\156\40\x3c\163\141\x6d\154\72\101\163\x73\x65\162\x74\x69\x6f\x6e\76\40\156\x6f\x74\40\163\x75\160\x70\x6f\x72\164\x65\x64\56");
        cw:
        $gj = $HP[0];
        if ($gj->hasAttribute("\x41\x75\x74\150\156\111\156\163\x74\141\156\x74")) {
            goto bn;
        }
        throw new Exception("\x4d\x69\x73\x73\151\156\147\x20\x72\145\161\165\x69\162\x65\144\40\x41\x75\x74\150\156\x49\x6e\163\x74\141\156\x74\x20\x61\164\164\162\151\142\x75\x74\145\40\x6f\x6e\x20\74\163\141\x6d\x6c\x3a\101\x75\164\x68\156\123\x74\x61\x74\x65\155\x65\x6e\164\x3e\x2e");
        bn:
        $this->authnInstant = SAMLSPUtilities::xsDateTimeToTimestamp($gj->getAttribute("\x41\x75\164\150\x6e\x49\156\163\x74\141\x6e\164"));
        if (!$gj->hasAttribute("\123\x65\x73\x73\x69\157\156\116\x6f\x74\117\x6e\117\162\101\146\164\x65\x72")) {
            goto rI;
        }
        $this->sessionNotOnOrAfter = SAMLSPUtilities::xsDateTimeToTimestamp($gj->getAttribute("\x53\145\163\163\x69\157\156\116\157\164\117\x6e\x4f\x72\x41\146\164\x65\162"));
        rI:
        if (!$gj->hasAttribute("\123\x65\163\163\151\x6f\156\x49\156\x64\145\x78")) {
            goto jx;
        }
        $this->sessionIndex = $gj->getAttribute("\x53\x65\x73\163\151\x6f\x6e\111\156\144\145\170");
        jx:
        $this->parseAuthnContext($gj);
    }
    private function parseAuthnContext(DOMElement $nT)
    {
        $OX = SAMLSPUtilities::xpQuery($nT, "\x2e\57\163\141\x6d\x6c\x5f\x61\163\x73\145\162\x74\x69\157\156\x3a\101\165\x74\x68\156\103\x6f\x6e\x74\x65\x78\164");
        if (count($OX) > 1) {
            goto nQ;
        }
        if (empty($OX)) {
            goto Ub;
        }
        goto d4;
        nQ:
        throw new Exception("\x4d\157\x72\x65\40\164\150\x61\156\x20\157\x6e\x65\40\x3c\x73\x61\x6d\154\72\101\x75\164\x68\156\103\x6f\156\x74\145\x78\x74\x3e\40\x69\x6e\x20\74\163\x61\x6d\154\x3a\101\165\x74\150\156\123\x74\x61\164\145\155\x65\x6e\x74\x3e\56");
        goto d4;
        Ub:
        throw new Exception("\115\151\163\163\x69\x6e\147\40\162\145\x71\x75\x69\x72\145\144\x20\74\x73\141\155\x6c\x3a\x41\x75\164\150\156\x43\157\x6e\164\145\170\x74\76\x20\x69\x6e\40\74\x73\141\155\154\x3a\x41\x75\164\150\x6e\x53\x74\x61\164\x65\x6d\x65\x6e\164\x3e\x2e");
        d4:
        $Aq = $OX[0];
        $M2 = SAMLSPUtilities::xpQuery($Aq, "\56\x2f\x73\141\x6d\x6c\137\x61\x73\x73\x65\162\164\x69\x6f\x6e\72\101\x75\164\x68\156\103\x6f\x6e\164\x65\x78\164\x44\145\143\x6c\122\x65\146");
        if (count($M2) > 1) {
            goto Jj;
        }
        if (count($M2) === 1) {
            goto KB;
        }
        goto Rd;
        Jj:
        throw new Exception("\115\x6f\x72\145\40\164\x68\141\156\x20\x6f\156\x65\x20\x3c\x73\141\x6d\x6c\72\x41\x75\164\x68\156\x43\157\x6e\x74\145\170\x74\x44\145\143\154\122\x65\146\x3e\40\146\x6f\165\x6e\x64\77");
        goto Rd;
        KB:
        $this->setAuthnContextDeclRef(trim($M2[0]->textContent));
        Rd:
        $yh = SAMLSPUtilities::xpQuery($Aq, "\x2e\57\163\x61\155\x6c\137\141\x73\x73\145\162\164\x69\157\x6e\x3a\101\x75\164\150\x6e\103\x6f\x6e\x74\x65\x78\x74\104\x65\143\154");
        if (count($yh) > 1) {
            goto zV;
        }
        if (count($yh) === 1) {
            goto Po;
        }
        goto Fq;
        zV:
        throw new Exception("\115\157\162\x65\x20\x74\x68\141\156\40\157\156\145\40\74\x73\141\x6d\x6c\x3a\x41\x75\164\150\x6e\x43\x6f\156\x74\x65\x78\164\x44\x65\143\x6c\x3e\x20\146\x6f\165\x6e\x64\x3f");
        goto Fq;
        Po:
        $this->setAuthnContextDecl(new SAML2_XML_Chunk($yh[0]));
        Fq:
        $x3 = SAMLSPUtilities::xpQuery($Aq, "\x2e\x2f\163\141\155\x6c\137\141\x73\163\145\162\x74\151\157\x6e\72\x41\x75\x74\x68\x6e\x43\x6f\156\x74\145\170\x74\103\154\141\163\163\x52\145\x66");
        if (count($x3) > 1) {
            goto HD;
        }
        if (count($x3) === 1) {
            goto nO;
        }
        goto Qn;
        HD:
        throw new Exception("\115\157\x72\145\40\x74\x68\141\156\x20\x6f\156\x65\40\74\163\141\x6d\154\72\101\x75\164\x68\x6e\x43\x6f\156\164\x65\170\x74\x43\154\141\163\163\122\x65\146\76\40\x69\156\x20\74\x73\x61\155\154\72\x41\165\164\150\x6e\x43\x6f\x6e\x74\145\170\x74\x3e\56");
        goto Qn;
        nO:
        $this->setAuthnContextClassRef(trim($x3[0]->textContent));
        Qn:
        if (!(empty($this->authnContextClassRef) && empty($this->authnContextDecl) && empty($this->authnContextDeclRef))) {
            goto AU;
        }
        throw new Exception("\115\x69\163\163\151\x6e\147\40\x65\151\164\150\x65\162\x20\x3c\x73\x61\x6d\x6c\x3a\x41\x75\x74\x68\156\103\157\x6e\164\145\x78\164\x43\x6c\x61\163\163\122\x65\146\x3e\40\x6f\x72\40\x3c\163\x61\x6d\154\72\x41\165\x74\150\x6e\x43\157\156\164\145\x78\164\104\x65\143\x6c\122\x65\x66\x3e\x20\x6f\162\40\74\x73\x61\155\154\x3a\101\x75\x74\x68\156\x43\x6f\156\x74\x65\170\164\104\x65\x63\x6c\76");
        AU:
        $this->AuthenticatingAuthority = SAMLSPUtilities::extractStrings($Aq, "\165\162\156\x3a\157\141\163\151\x73\72\x6e\141\x6d\x65\x73\x3a\164\143\x3a\123\x41\115\x4c\72\x32\56\x30\72\x61\x73\163\x65\x72\164\151\x6f\156", "\101\x75\x74\150\x65\x6e\x74\x69\143\x61\164\151\156\147\101\165\164\150\157\162\x69\x74\171");
    }
    private function parseAttributes(DOMElement $ER)
    {
        $P_ = TRUE;
        $eR = SAMLSPUtilities::xpQuery($ER, "\x2e\x2f\x73\141\x6d\154\137\x61\163\163\145\162\x74\151\157\x6e\72\x41\164\x74\162\x69\142\x75\x74\x65\x53\164\141\x74\145\155\x65\x6e\164\57\x73\141\155\154\x5f\141\x73\163\x65\162\x74\151\157\x6e\x3a\x41\164\164\162\x69\x62\165\x74\145");
        foreach ($eR as $yz) {
            if ($yz->hasAttribute("\x4e\141\155\x65")) {
                goto tn;
            }
            throw new Exception("\115\151\x73\163\x69\x6e\x67\x20\156\141\155\x65\40\157\x6e\40\x3c\163\141\155\x6c\72\101\x74\x74\162\151\142\165\x74\145\x3e\40\x65\154\145\x6d\x65\156\164\56");
            tn:
            $SC = $yz->getAttribute("\x4e\141\x6d\x65");
            if ($yz->hasAttribute("\116\141\x6d\145\106\157\x72\155\141\164")) {
                goto I9;
            }
            $g6 = "\165\162\x6e\72\x6f\x61\x73\x69\163\72\156\141\x6d\145\163\x3a\x74\x63\x3a\x53\x41\115\x4c\72\x31\56\61\72\x6e\141\155\x65\x69\x64\55\146\x6f\162\155\x61\x74\72\x75\x6e\x73\160\145\x63\151\146\151\145\144";
            goto rO;
            I9:
            $g6 = $yz->getAttribute("\116\x61\155\x65\106\x6f\162\155\141\x74");
            rO:
            if ($P_) {
                goto JP;
            }
            if (!($this->nameFormat !== $g6)) {
                goto Gr;
            }
            $this->nameFormat = "\165\162\x6e\x3a\x6f\x61\163\x69\163\72\x6e\141\155\x65\163\72\164\x63\x3a\123\x41\115\114\72\61\x2e\61\x3a\156\x61\155\145\151\x64\x2d\x66\x6f\162\x6d\x61\164\x3a\x75\x6e\163\x70\145\143\x69\146\x69\x65\144";
            Gr:
            goto Pu;
            JP:
            $this->nameFormat = $g6;
            $P_ = FALSE;
            Pu:
            if (isset($this->attributes[$SC])) {
                goto cl;
            }
            $this->attributes[$SC] = array();
            cl:
            $YD = SAMLSPUtilities::xpQuery($yz, "\x2e\57\163\x61\155\x6c\137\141\163\163\145\162\x74\151\x6f\x6e\72\101\164\164\162\151\142\165\x74\x65\x56\x61\x6c\165\x65");
            foreach ($YD as $nY) {
                $this->attributes[$SC][] = trim($nY->textContent);
                He:
            }
            YL:
            YS:
        }
        sB:
    }
    private function parseEncryptedAttributes(DOMElement $ER)
    {
        $this->encryptedAttribute = SAMLSPUtilities::xpQuery($ER, "\x2e\x2f\163\x61\155\x6c\x5f\x61\x73\163\x65\162\164\x69\x6f\x6e\x3a\101\x74\164\162\151\x62\165\164\x65\123\x74\x61\x74\145\155\x65\x6e\x74\57\x73\x61\155\154\x5f\141\163\163\145\x72\164\x69\157\x6e\x3a\105\156\x63\162\x79\160\x74\145\144\101\164\x74\x72\151\142\165\x74\x65");
    }
    private function parseSignature(DOMElement $ER)
    {
        $Io = SAMLSPUtilities::validateElement($ER);
        if (!($Io !== FALSE)) {
            goto aA;
        }
        $this->wasSignedAtConstruction = TRUE;
        $this->certificates = $Io["\103\145\162\164\x69\x66\x69\x63\x61\x74\145\163"];
        $this->signatureData = $Io;
        aA:
    }
    public function validate(XMLSecurityKey $Xx)
    {
        if (!($this->signatureData === NULL)) {
            goto fe;
        }
        return FALSE;
        fe:
        SAMLSPUtilities::validateSignature($this->signatureData, $Xx);
        return TRUE;
    }
    public function getId()
    {
        return $this->id;
    }
    public function setId($QY)
    {
        $this->id = $QY;
    }
    public function getIssueInstant()
    {
        return $this->issueInstant;
    }
    public function setIssueInstant($iv)
    {
        $this->issueInstant = $iv;
    }
    public function getIssuer()
    {
        return $this->issuer;
    }
    public function setIssuer($CL)
    {
        $this->issuer = $CL;
    }
    public function getNameId()
    {
        if (!($this->encryptedNameId !== NULL)) {
            goto iO;
        }
        throw new Exception("\101\x74\164\145\155\x70\164\x65\x64\40\164\157\x20\162\x65\x74\x72\x69\145\166\x65\x20\x65\x6e\x63\162\171\160\164\145\x64\x20\116\141\155\x65\111\104\40\167\x69\164\x68\x6f\165\164\x20\x64\145\x63\x72\171\160\x74\151\x6e\x67\x20\x69\164\x20\x66\x69\x72\x73\164\56");
        iO:
        return $this->nameId;
    }
    public function setNameId($uO)
    {
        $this->nameId = $uO;
    }
    public function isNameIdEncrypted()
    {
        if (!($this->encryptedNameId !== NULL)) {
            goto xm;
        }
        return TRUE;
        xm:
        return FALSE;
    }
    public function encryptNameId(XMLSecurityKey $Xx)
    {
        $X_ = new DOMDocument();
        $MO = $X_->createElement("\x72\157\157\x74");
        $X_->appendChild($MO);
        SAMLSPUtilities::addNameId($MO, $this->nameId);
        $uO = $MO->firstChild;
        SAMLSPUtilities::getContainer()->debugMessage($uO, "\x65\156\x63\x72\x79\x70\x74");
        $J0 = new XMLSecEnc();
        $J0->setNode($uO);
        $J0->type = XMLSecEnc::Element;
        $g3 = new XMLSecurityKey(XMLSecurityKey::AES128_CBC);
        $g3->generateSessionKey();
        $J0->encryptKey($Xx, $g3);
        $this->encryptedNameId = $J0->encryptNode($g3);
        $this->nameId = NULL;
    }
    public function decryptNameId(XMLSecurityKey $Xx, array $TJ = array())
    {
        if (!($this->encryptedNameId === NULL)) {
            goto LX;
        }
        return;
        LX:
        $uO = SAMLSPUtilities::decryptElement($this->encryptedNameId, $Xx, $TJ);
        SAMLSPUtilities::getContainer()->debugMessage($uO, "\x64\145\143\x72\x79\160\164");
        $this->nameId = SAMLSPUtilities::parseNameId($uO);
        $this->encryptedNameId = NULL;
    }
    public function decryptAttributes(XMLSecurityKey $Xx, array $TJ = array())
    {
        if (!($this->encryptedAttribute === NULL)) {
            goto HE;
        }
        return;
        HE:
        $P_ = TRUE;
        $eR = $this->encryptedAttribute;
        foreach ($eR as $bX) {
            $yz = SAMLSPUtilities::decryptElement($bX->getElementsByTagName("\105\156\x63\162\171\160\x74\145\x64\x44\141\x74\141")->item(0), $Xx, $TJ);
            if ($yz->hasAttribute("\116\141\x6d\145")) {
                goto XR;
            }
            throw new Exception("\x4d\151\x73\163\151\156\147\40\x6e\141\155\145\x20\x6f\156\x20\74\x73\x61\155\154\x3a\101\x74\x74\162\151\142\165\164\x65\76\40\x65\x6c\x65\x6d\145\156\164\56");
            XR:
            $SC = $yz->getAttribute("\116\141\x6d\145");
            if ($yz->hasAttribute("\116\141\x6d\x65\106\x6f\162\x6d\141\164")) {
                goto ds;
            }
            $g6 = "\x75\162\x6e\x3a\x6f\141\163\x69\x73\72\x6e\x61\155\x65\x73\72\x74\143\x3a\x53\x41\x4d\x4c\x3a\62\x2e\x30\x3a\141\164\x74\162\156\141\x6d\145\x2d\x66\157\162\155\x61\164\x3a\165\x6e\163\160\145\143\151\x66\151\145\x64";
            goto Wl;
            ds:
            $g6 = $yz->getAttribute("\116\141\x6d\145\106\157\162\155\x61\x74");
            Wl:
            if ($P_) {
                goto ZO;
            }
            if (!($this->nameFormat !== $g6)) {
                goto F3;
            }
            $this->nameFormat = "\165\162\156\x3a\157\141\x73\x69\x73\x3a\x6e\141\155\x65\x73\72\164\143\72\123\101\x4d\114\x3a\x32\56\x30\72\x61\x74\164\x72\156\x61\155\145\55\146\x6f\x72\x6d\141\164\x3a\165\156\x73\x70\145\143\151\146\151\145\144";
            F3:
            goto vH;
            ZO:
            $this->nameFormat = $g6;
            $P_ = FALSE;
            vH:
            if (isset($this->attributes[$SC])) {
                goto XN;
            }
            $this->attributes[$SC] = array();
            XN:
            $YD = SAMLSPUtilities::xpQuery($yz, "\56\x2f\x73\141\155\x6c\x5f\x61\163\163\145\x72\164\151\157\x6e\72\x41\x74\x74\x72\x69\x62\165\164\x65\126\141\154\165\145");
            foreach ($YD as $nY) {
                $this->attributes[$SC][] = trim($nY->textContent);
                un:
            }
            B2:
            Nu:
        }
        ns:
    }
    public function getNotBefore()
    {
        return $this->notBefore;
    }
    public function setNotBefore($Hr)
    {
        $this->notBefore = $Hr;
    }
    public function getNotOnOrAfter()
    {
        return $this->notOnOrAfter;
    }
    public function setNotOnOrAfter($H0)
    {
        $this->notOnOrAfter = $H0;
    }
    public function setEncryptedAttributes($aC)
    {
        $this->requiredEncAttributes = $aC;
    }
    public function getValidAudiences()
    {
        return $this->validAudiences;
    }
    public function setValidAudiences(array $rc = NULL)
    {
        $this->validAudiences = $rc;
    }
    public function getAuthnInstant()
    {
        return $this->authnInstant;
    }
    public function setAuthnInstant($GP)
    {
        $this->authnInstant = $GP;
    }
    public function getSessionNotOnOrAfter()
    {
        return $this->sessionNotOnOrAfter;
    }
    public function setSessionNotOnOrAfter($bQ)
    {
        $this->sessionNotOnOrAfter = $bQ;
    }
    public function getSessionIndex()
    {
        return $this->sessionIndex;
    }
    public function setSessionIndex($L3)
    {
        $this->sessionIndex = $L3;
    }
    public function getAuthnContext()
    {
        if (empty($this->authnContextClassRef)) {
            goto Zm;
        }
        return $this->authnContextClassRef;
        Zm:
        if (empty($this->authnContextDeclRef)) {
            goto uZ;
        }
        return $this->authnContextDeclRef;
        uZ:
        return NULL;
    }
    public function setAuthnContext($gD)
    {
        $this->setAuthnContextClassRef($gD);
    }
    public function getAuthnContextClassRef()
    {
        return $this->authnContextClassRef;
    }
    public function setAuthnContextClassRef($kA)
    {
        $this->authnContextClassRef = $kA;
    }
    public function setAuthnContextDecl(SAML2_XML_Chunk $Eb)
    {
        if (empty($this->authnContextDeclRef)) {
            goto cK;
        }
        throw new Exception("\x41\x75\x74\150\156\x43\157\156\x74\145\170\x74\104\145\143\x6c\122\x65\x66\40\x69\x73\x20\x61\154\162\x65\x61\x64\171\x20\x72\x65\x67\151\x73\x74\x65\162\145\144\x21\x20\x4d\141\171\40\157\156\154\171\x20\150\141\x76\145\40\145\151\164\150\145\162\x20\141\40\x44\x65\x63\154\x20\x6f\162\40\141\40\104\145\x63\x6c\x52\x65\x66\x2c\40\156\x6f\x74\40\142\157\164\x68\x21");
        cK:
        $this->authnContextDecl = $Eb;
    }
    public function getAuthnContextDecl()
    {
        return $this->authnContextDecl;
    }
    public function setAuthnContextDeclRef($ik)
    {
        if (empty($this->authnContextDecl)) {
            goto YJ;
        }
        throw new Exception("\x41\165\164\150\x6e\103\157\156\164\x65\x78\164\104\145\x63\154\40\x69\x73\x20\x61\154\x72\145\x61\144\171\x20\x72\x65\x67\x69\x73\164\145\x72\x65\144\41\x20\x4d\x61\171\40\157\x6e\x6c\x79\40\x68\x61\x76\x65\40\145\151\x74\x68\x65\x72\x20\141\x20\x44\x65\x63\154\x20\157\162\40\x61\x20\104\x65\143\x6c\122\145\x66\54\40\156\x6f\164\x20\142\x6f\x74\150\41");
        YJ:
        $this->authnContextDeclRef = $ik;
    }
    public function getAuthnContextDeclRef()
    {
        return $this->authnContextDeclRef;
    }
    public function getAuthenticatingAuthority()
    {
        return $this->AuthenticatingAuthority;
    }
    public function setAuthenticatingAuthority($nX)
    {
        $this->AuthenticatingAuthority = $nX;
    }
    public function getAttributes()
    {
        return $this->attributes;
    }
    public function setAttributes(array $eR)
    {
        $this->attributes = $eR;
    }
    public function getAttributeNameFormat()
    {
        return $this->nameFormat;
    }
    public function setAttributeNameFormat($g6)
    {
        $this->nameFormat = $g6;
    }
    public function getSubjectConfirmation()
    {
        return $this->SubjectConfirmation;
    }
    public function setSubjectConfirmation(array $fB)
    {
        $this->SubjectConfirmation = $fB;
    }
    public function getSignatureKey()
    {
        return $this->signatureKey;
    }
    public function setSignatureKey(XMLsecurityKey $qu = NULL)
    {
        $this->signatureKey = $qu;
    }
    public function getEncryptionKey()
    {
        return $this->encryptionKey;
    }
    public function setEncryptionKey(XMLSecurityKey $kF = NULL)
    {
        $this->encryptionKey = $kF;
    }
    public function setCertificates(array $RH)
    {
        $this->certificates = $RH;
    }
    public function getCertificates()
    {
        return $this->certificates;
    }
    public function getSignatureData()
    {
        return $this->signatureData;
    }
    public function getWasSignedAtConstruction()
    {
        return $this->wasSignedAtConstruction;
    }
    public function toXML(DOMNode $CS = NULL)
    {
        if ($CS === NULL) {
            goto h0;
        }
        $Nb = $CS->ownerDocument;
        goto jM;
        h0:
        $Nb = new DOMDocument();
        $CS = $Nb;
        jM:
        $MO = $Nb->createElementNS("\165\162\156\72\x6f\141\x73\151\163\72\x6e\141\155\145\163\x3a\x74\x63\x3a\123\x41\x4d\x4c\x3a\62\56\x30\72\141\163\x73\x65\162\164\x69\x6f\x6e", "\x73\x61\155\154\72" . "\x41\163\x73\145\x72\164\151\x6f\x6e");
        $CS->appendChild($MO);
        $MO->setAttributeNS("\x75\162\x6e\72\157\141\163\151\x73\72\156\x61\155\x65\163\x3a\164\143\x3a\123\x41\115\114\72\62\x2e\60\72\160\162\157\x74\157\x63\x6f\154", "\x73\141\155\154\x70\x3a\164\155\x70", "\164\155\x70");
        $MO->removeAttributeNS("\165\162\156\72\x6f\141\x73\151\x73\72\156\x61\x6d\145\x73\72\x74\143\72\x53\101\115\114\x3a\62\56\60\x3a\160\162\x6f\x74\157\143\x6f\154", "\164\x6d\160");
        $MO->setAttributeNS("\x68\x74\x74\x70\72\57\x2f\167\x77\167\x2e\x77\63\56\157\x72\147\57\62\x30\60\x31\x2f\130\115\x4c\123\x63\x68\x65\x6d\141\x2d\x69\156\163\164\x61\156\x63\145", "\170\163\151\72\x74\x6d\x70", "\164\x6d\160");
        $MO->removeAttributeNS("\x68\164\x74\x70\72\x2f\x2f\x77\167\167\x2e\x77\63\x2e\157\162\147\57\62\60\x30\61\57\x58\115\114\x53\x63\x68\x65\x6d\141\55\x69\156\163\164\141\156\143\145", "\164\155\160");
        $MO->setAttributeNS("\150\164\x74\160\x3a\x2f\57\167\167\x77\56\x77\63\56\157\x72\147\x2f\62\60\60\x31\57\x58\115\114\123\143\x68\145\x6d\x61", "\170\163\72\164\x6d\160", "\x74\x6d\x70");
        $MO->removeAttributeNS("\x68\164\x74\x70\x3a\x2f\57\x77\x77\167\x2e\x77\63\x2e\157\x72\147\57\62\x30\x30\x31\57\x58\115\114\123\x63\150\145\x6d\141", "\164\x6d\x70");
        $MO->setAttribute("\x49\104", $this->id);
        $MO->setAttribute("\126\x65\x72\x73\151\x6f\x6e", "\x32\56\60");
        $MO->setAttribute("\111\x73\x73\165\x65\x49\156\163\164\141\156\164", gmdate("\131\55\x6d\55\144\134\x54\x48\72\151\72\163\x5c\132", $this->issueInstant));
        $CL = SAMLSPUtilities::addString($MO, "\165\x72\x6e\72\157\x61\x73\x69\x73\x3a\x6e\141\x6d\x65\163\72\x74\143\x3a\123\x41\x4d\x4c\x3a\62\x2e\x30\x3a\x61\163\x73\x65\x72\164\x69\157\x6e", "\163\141\155\154\x3a\x49\163\163\165\x65\162", $this->issuer);
        $this->addSubject($MO);
        $this->addConditions($MO);
        $this->addAuthnStatement($MO);
        if ($this->requiredEncAttributes == FALSE) {
            goto pV;
        }
        $this->addEncryptedAttributeStatement($MO);
        goto kF;
        pV:
        $this->addAttributeStatement($MO);
        kF:
        if (!($this->signatureKey !== NULL)) {
            goto fM;
        }
        SAMLSPUtilities::insertSignature($this->signatureKey, $this->certificates, $MO, $CL->nextSibling);
        fM:
        return $MO;
    }
    private function addSubject(DOMElement $MO)
    {
        if (!($this->nameId === NULL && $this->encryptedNameId === NULL)) {
            goto it;
        }
        return;
        it:
        $jR = $MO->ownerDocument->createElementNS("\x75\162\x6e\72\157\x61\x73\151\x73\72\156\141\x6d\145\163\72\164\x63\72\123\x41\x4d\x4c\72\x32\56\60\x3a\x61\x73\x73\145\x72\x74\151\157\156", "\163\x61\x6d\154\72\x53\x75\142\x6a\145\x63\x74");
        $MO->appendChild($jR);
        if ($this->encryptedNameId === NULL) {
            goto Kj;
        }
        $bc = $jR->ownerDocument->createElementNS("\165\x72\x6e\x3a\157\141\163\151\x73\x3a\x6e\x61\155\145\x73\72\164\x63\x3a\x53\101\x4d\114\72\62\56\x30\72\141\x73\x73\x65\x72\164\151\157\x6e", "\163\141\155\154\x3a" . "\105\156\x63\x72\171\x70\164\145\144\111\x44");
        $jR->appendChild($bc);
        $bc->appendChild($jR->ownerDocument->importNode($this->encryptedNameId, TRUE));
        goto iX;
        Kj:
        SAMLSPUtilities::addNameId($jR, $this->nameId);
        iX:
        foreach ($this->SubjectConfirmation as $Xz) {
            $Xz->toXML($jR);
            nS:
        }
        ZA:
    }
    private function addConditions(DOMElement $MO)
    {
        $Nb = $MO->ownerDocument;
        $T4 = $Nb->createElementNS("\x75\162\x6e\72\x6f\x61\163\151\163\x3a\x6e\x61\155\145\x73\x3a\164\x63\x3a\x53\x41\x4d\114\x3a\62\x2e\60\72\141\x73\163\x65\162\x74\x69\x6f\x6e", "\x73\x61\155\154\x3a\x43\x6f\156\x64\151\164\151\x6f\156\163");
        $MO->appendChild($T4);
        if (!($this->notBefore !== NULL)) {
            goto NB;
        }
        $T4->setAttribute("\x4e\x6f\164\x42\145\146\157\x72\x65", gmdate("\131\x2d\x6d\x2d\x64\134\x54\x48\x3a\x69\x3a\163\x5c\132", $this->notBefore));
        NB:
        if (!($this->notOnOrAfter !== NULL)) {
            goto FB;
        }
        $T4->setAttribute("\116\x6f\164\117\156\x4f\162\101\146\164\x65\x72", gmdate("\x59\x2d\x6d\55\x64\x5c\124\x48\72\151\72\163\134\x5a", $this->notOnOrAfter));
        FB:
        if (!($this->validAudiences !== NULL)) {
            goto uA;
        }
        $EM = $Nb->createElementNS("\x75\162\156\x3a\x6f\x61\163\x69\163\72\156\141\x6d\145\163\72\x74\x63\72\123\101\115\114\72\62\x2e\x30\72\141\x73\x73\x65\162\164\x69\157\156", "\163\x61\155\154\72\x41\x75\144\151\x65\x6e\143\145\x52\145\163\x74\162\x69\143\164\x69\157\156");
        $T4->appendChild($EM);
        SAMLSPUtilities::addStrings($EM, "\165\162\156\72\x6f\x61\163\151\163\72\x6e\141\x6d\145\x73\72\164\143\x3a\123\x41\x4d\114\72\62\x2e\x30\x3a\141\163\x73\x65\x72\x74\151\x6f\x6e", "\x73\x61\155\x6c\72\101\x75\144\151\145\156\143\x65", FALSE, $this->validAudiences);
        uA:
    }
    private function addAuthnStatement(DOMElement $MO)
    {
        if (!($this->authnInstant === NULL || $this->authnContextClassRef === NULL && $this->authnContextDecl === NULL && $this->authnContextDeclRef === NULL)) {
            goto dC;
        }
        return;
        dC:
        $Nb = $MO->ownerDocument;
        $nT = $Nb->createElementNS("\x75\x72\156\x3a\157\141\163\x69\x73\72\x6e\x61\155\145\163\72\164\x63\72\x53\101\115\x4c\x3a\x32\56\60\72\x61\163\163\145\162\164\x69\157\x6e", "\x73\x61\x6d\154\x3a\101\x75\164\150\x6e\x53\x74\x61\164\x65\155\x65\x6e\164");
        $MO->appendChild($nT);
        $nT->setAttribute("\101\x75\164\150\156\111\156\x73\x74\141\156\164", gmdate("\131\x2d\155\55\x64\x5c\x54\x48\72\x69\72\163\x5c\x5a", $this->authnInstant));
        if (!($this->sessionNotOnOrAfter !== NULL)) {
            goto d3;
        }
        $nT->setAttribute("\x53\145\x73\163\151\157\x6e\x4e\157\164\x4f\x6e\x4f\162\101\146\164\145\162", gmdate("\x59\x2d\155\55\144\134\124\110\72\151\72\x73\134\132", $this->sessionNotOnOrAfter));
        d3:
        if (!($this->sessionIndex !== NULL)) {
            goto C7;
        }
        $nT->setAttribute("\x53\x65\163\163\151\x6f\156\x49\x6e\144\145\170", $this->sessionIndex);
        C7:
        $Aq = $Nb->createElementNS("\165\162\156\72\157\x61\163\x69\163\x3a\156\141\155\145\x73\72\164\x63\x3a\123\x41\115\114\72\x32\x2e\60\x3a\141\163\x73\x65\x72\164\x69\x6f\156", "\x73\x61\155\x6c\x3a\101\165\x74\150\156\x43\x6f\156\164\x65\x78\164");
        $nT->appendChild($Aq);
        if (empty($this->authnContextClassRef)) {
            goto NT;
        }
        SAMLSPUtilities::addString($Aq, "\x75\162\156\x3a\x6f\x61\163\x69\x73\x3a\x6e\x61\x6d\145\163\x3a\x74\x63\72\123\x41\x4d\x4c\x3a\x32\x2e\x30\72\141\x73\163\145\x72\x74\151\x6f\156", "\163\x61\x6d\x6c\72\x41\x75\164\x68\x6e\103\157\x6e\164\x65\170\164\103\154\x61\x73\163\122\x65\x66", $this->authnContextClassRef);
        NT:
        if (empty($this->authnContextDecl)) {
            goto g4;
        }
        $this->authnContextDecl->toXML($Aq);
        g4:
        if (empty($this->authnContextDeclRef)) {
            goto Q2;
        }
        SAMLSPUtilities::addString($Aq, "\165\162\x6e\x3a\157\x61\x73\x69\x73\x3a\156\x61\x6d\145\x73\x3a\164\x63\x3a\x53\101\115\114\x3a\x32\56\x30\72\x61\x73\x73\145\162\x74\151\157\156", "\163\141\x6d\x6c\72\101\165\164\150\x6e\103\157\x6e\x74\x65\170\x74\104\145\143\154\x52\145\146", $this->authnContextDeclRef);
        Q2:
        SAMLSPUtilities::addStrings($Aq, "\x75\x72\156\72\157\141\163\151\163\72\156\141\155\145\x73\x3a\x74\143\72\x53\x41\115\x4c\72\x32\x2e\60\x3a\141\163\163\145\162\x74\x69\x6f\156", "\163\141\x6d\x6c\x3a\x41\x75\x74\x68\x65\156\x74\x69\143\141\164\x69\156\x67\101\x75\164\x68\157\x72\x69\164\x79", FALSE, $this->AuthenticatingAuthority);
    }
    private function addAttributeStatement(DOMElement $MO)
    {
        if (!empty($this->attributes)) {
            goto CU;
        }
        return;
        CU:
        $Nb = $MO->ownerDocument;
        $N7 = $Nb->createElementNS("\165\x72\156\x3a\157\x61\163\151\163\72\x6e\141\155\145\x73\72\x74\x63\x3a\123\x41\115\x4c\x3a\x32\x2e\x30\x3a\141\163\163\145\x72\x74\x69\157\x6e", "\163\x61\155\154\72\x41\164\x74\162\151\x62\x75\164\x65\x53\x74\141\x74\x65\155\x65\x6e\164");
        $MO->appendChild($N7);
        foreach ($this->attributes as $SC => $YD) {
            $yz = $Nb->createElementNS("\165\162\156\x3a\x6f\141\163\151\x73\x3a\156\x61\x6d\145\163\x3a\164\143\72\x53\101\x4d\x4c\x3a\x32\x2e\60\72\141\163\163\145\162\164\151\x6f\156", "\163\141\x6d\154\72\x41\x74\x74\162\151\x62\165\x74\145");
            $N7->appendChild($yz);
            $yz->setAttribute("\116\x61\155\145", $SC);
            if (!($this->nameFormat !== "\x75\x72\156\72\x6f\141\163\x69\x73\72\156\x61\155\145\163\72\164\143\x3a\123\101\115\x4c\72\62\56\x30\x3a\x61\x74\164\x72\156\x61\155\x65\55\x66\x6f\x72\155\x61\x74\72\165\156\163\x70\145\x63\x69\146\x69\145\x64")) {
                goto Q3;
            }
            $yz->setAttribute("\116\x61\x6d\x65\106\157\x72\155\141\164", $this->nameFormat);
            Q3:
            foreach ($YD as $nY) {
                if (is_string($nY)) {
                    goto hr;
                }
                if (is_int($nY)) {
                    goto Zh;
                }
                $kY = NULL;
                goto sA;
                hr:
                $kY = "\x78\163\x3a\163\164\162\x69\x6e\x67";
                goto sA;
                Zh:
                $kY = "\x78\163\72\151\x6e\164\x65\147\x65\x72";
                sA:
                $ah = $Nb->createElementNS("\165\x72\x6e\x3a\157\x61\163\151\163\x3a\156\x61\x6d\x65\x73\x3a\x74\x63\x3a\123\x41\x4d\x4c\x3a\62\x2e\x30\x3a\x61\163\x73\x65\162\x74\151\157\x6e", "\x73\141\x6d\x6c\x3a\101\164\164\162\x69\x62\165\164\145\x56\x61\x6c\x75\x65");
                $yz->appendChild($ah);
                if (!($kY !== NULL)) {
                    goto gK;
                }
                $ah->setAttributeNS("\x68\164\164\x70\x3a\x2f\57\x77\x77\x77\56\167\x33\56\157\x72\147\x2f\62\60\x30\61\x2f\130\115\x4c\123\143\150\x65\x6d\x61\55\151\156\x73\x74\x61\x6e\143\x65", "\x78\163\x69\72\164\x79\x70\145", $kY);
                gK:
                if (!is_null($nY)) {
                    goto mH;
                }
                $ah->setAttributeNS("\x68\x74\164\x70\72\x2f\57\167\167\167\x2e\167\x33\56\157\162\x67\57\62\x30\x30\x31\57\x58\115\x4c\123\x63\150\145\x6d\x61\x2d\151\156\163\x74\141\x6e\143\145", "\x78\163\x69\x3a\x6e\x69\154", "\x74\162\165\x65");
                mH:
                if ($nY instanceof DOMNodeList) {
                    goto v7;
                }
                $ah->appendChild($Nb->createTextNode($nY));
                goto s0;
                v7:
                $zB = 0;
                vE:
                if (!($zB < $nY->length)) {
                    goto a9;
                }
                $Bt = $Nb->importNode($nY->item($zB), TRUE);
                $ah->appendChild($Bt);
                aU:
                $zB++;
                goto vE;
                a9:
                s0:
                LS:
            }
            s3:
            u0:
        }
        IY:
    }
    private function addEncryptedAttributeStatement(DOMElement $MO)
    {
        if (!($this->requiredEncAttributes == FALSE)) {
            goto n3;
        }
        return;
        n3:
        $Nb = $MO->ownerDocument;
        $N7 = $Nb->createElementNS("\x75\162\x6e\72\x6f\x61\x73\x69\x73\72\156\x61\x6d\145\x73\x3a\x74\x63\72\x53\101\115\114\72\x32\56\60\x3a\x61\163\163\145\x72\164\x69\157\156", "\x73\141\x6d\x6c\72\x41\164\164\162\151\142\x75\164\145\123\x74\x61\164\x65\155\x65\156\164");
        $MO->appendChild($N7);
        foreach ($this->attributes as $SC => $YD) {
            $ca = new DOMDocument();
            $yz = $ca->createElementNS("\165\162\x6e\x3a\x6f\x61\x73\x69\x73\72\156\141\x6d\145\163\x3a\x74\143\72\x53\101\x4d\x4c\72\62\56\x30\72\x61\163\163\145\162\164\x69\x6f\156", "\x73\141\155\154\x3a\x41\x74\164\x72\151\142\165\x74\x65");
            $yz->setAttribute("\x4e\141\x6d\x65", $SC);
            $ca->appendChild($yz);
            if (!($this->nameFormat !== "\x75\162\x6e\72\157\141\x73\151\163\x3a\x6e\141\155\x65\163\x3a\x74\143\x3a\123\x41\115\114\x3a\x32\x2e\60\72\141\x74\x74\x72\x6e\x61\x6d\145\x2d\x66\x6f\x72\x6d\x61\x74\x3a\165\x6e\x73\160\145\x63\x69\x66\x69\145\144")) {
                goto Ly;
            }
            $yz->setAttribute("\116\141\x6d\145\106\157\162\x6d\141\x74", $this->nameFormat);
            Ly:
            foreach ($YD as $nY) {
                if (is_string($nY)) {
                    goto ei;
                }
                if (is_int($nY)) {
                    goto TU;
                }
                $kY = NULL;
                goto kR;
                ei:
                $kY = "\170\163\72\x73\164\162\151\x6e\147";
                goto kR;
                TU:
                $kY = "\x78\163\72\151\156\x74\x65\x67\x65\x72";
                kR:
                $ah = $ca->createElementNS("\165\x72\156\72\157\x61\x73\x69\163\72\156\x61\x6d\x65\163\x3a\x74\x63\72\x53\101\x4d\x4c\72\62\x2e\60\72\x61\163\x73\x65\x72\164\151\x6f\156", "\x73\x61\155\154\72\101\164\x74\162\x69\142\165\x74\x65\126\141\x6c\x75\145");
                $yz->appendChild($ah);
                if (!($kY !== NULL)) {
                    goto MB;
                }
                $ah->setAttributeNS("\150\x74\164\160\x3a\57\x2f\167\x77\x77\x2e\167\63\x2e\157\162\x67\57\x32\x30\x30\61\x2f\130\115\x4c\123\x63\x68\145\155\x61\x2d\x69\156\163\x74\x61\156\143\x65", "\170\163\151\72\x74\171\160\x65", $kY);
                MB:
                if ($nY instanceof DOMNodeList) {
                    goto Mf;
                }
                $ah->appendChild($ca->createTextNode($nY));
                goto P3;
                Mf:
                $zB = 0;
                nK:
                if (!($zB < $nY->length)) {
                    goto Qj;
                }
                $Bt = $ca->importNode($nY->item($zB), TRUE);
                $ah->appendChild($Bt);
                Hu:
                $zB++;
                goto nK;
                Qj:
                P3:
                iL:
            }
            fX:
            $oR = new XMLSecEnc();
            $oR->setNode($ca->documentElement);
            $oR->type = "\150\164\x74\x70\72\x2f\57\167\x77\167\56\167\x33\x2e\157\x72\147\x2f\62\x30\60\x31\x2f\60\64\x2f\170\155\154\145\x6e\x63\43\105\154\x65\x6d\145\156\x74";
            $g3 = new XMLSecurityKey(XMLSecurityKey::AES256_CBC);
            $g3->generateSessionKey();
            $oR->encryptKey($this->encryptionKey, $g3);
            $TM = $oR->encryptNode($g3);
            $wb = $Nb->createElementNS("\x75\x72\156\x3a\x6f\141\163\x69\x73\72\156\141\x6d\x65\x73\72\164\x63\72\x53\101\115\x4c\x3a\x32\x2e\x30\x3a\x61\163\x73\x65\x72\x74\x69\x6f\x6e", "\163\x61\x6d\x6c\x3a\x45\x6e\143\x72\x79\160\164\x65\144\101\x74\164\x72\151\142\x75\x74\145");
            $N7->appendChild($wb);
            $sF = $Nb->importNode($TM, TRUE);
            $wb->appendChild($sF);
            y9:
        }
        WZ:
    }
    public function getPrivateKeyUrl()
    {
        return $this->privateKeyUrl;
    }
    public function setPrivateKeyUrl($kk)
    {
        $this->privateKeyUrl = $kk;
    }
}
