<?php
/**
 * This file is a part of the miniorange-saml-20-single-sign-on plugin.
 *
 * @link https://plugins.miniorange.com/
 * @author miniOrange
 * @package miniorange-saml-20-single-sign-on
 */


use RobRichards\XMLSecLibs\XMLSecurityKey;
use RobRichards\XMLSecLibs\XMLSecurityDSig;
use RobRichards\XMLSecLibs\XMLSecEnc;
class SAML2SPLogoutRequest
{
    private $tagName;
    private $id;
    private $issuer;
    private $destination;
    private $issueInstant;
    private $certificates;
    private $validators;
    private $notOnOrAfter;
    private $encryptedNameId;
    private $nameId;
    private $sessionIndexes;
    public function __construct(DOMElement $ER = NULL)
    {
        $this->tagName = "\114\157\147\157\x75\x74\x52\x65\x71\165\145\x73\164";
        $this->id = SAMLSPUtilities::generateID();
        $this->issueInstant = time();
        $this->certificates = array();
        $this->validators = array();
        if (!($ER === NULL)) {
            goto MK;
        }
        return;
        MK:
        if ($ER->hasAttribute("\111\104")) {
            goto TZ;
        }
        throw new Exception("\115\x69\x73\163\x69\x6e\147\40\111\x44\x20\x61\x74\164\x72\151\x62\165\x74\145\40\157\x6e\40\123\x41\x4d\114\40\155\x65\x73\x73\x61\147\x65\x2e");
        TZ:
        $this->id = $ER->getAttribute("\x49\x44");
        if (!($ER->getAttribute("\x56\145\162\x73\151\x6f\x6e") !== "\62\56\x30")) {
            goto Q9;
        }
        throw new Exception("\125\x6e\x73\165\160\160\157\162\x74\x65\x64\x20\x76\x65\162\x73\151\157\x6e\72\40" . $ER->getAttribute("\x56\x65\x72\x73\x69\157\156"));
        Q9:
        $this->issueInstant = SAMLSPUtilities::xsDateTimeToTimestamp($ER->getAttribute("\x49\x73\163\165\145\111\x6e\163\164\141\156\164"));
        if (!$ER->hasAttribute("\x44\x65\163\164\151\x6e\141\164\x69\157\156")) {
            goto iC;
        }
        $this->destination = $ER->getAttribute("\104\x65\163\164\151\156\x61\x74\151\157\156");
        iC:
        $CL = SAMLSPUtilities::xpQuery($ER, "\x2e\57\163\x61\155\x6c\x5f\x61\163\x73\x65\162\164\151\x6f\x6e\x3a\x49\163\x73\165\x65\x72");
        if (empty($CL)) {
            goto Df;
        }
        $this->issuer = trim($CL[0]->textContent);
        Df:
        try {
            $Io = SAMLSPUtilities::validateElement($ER);
            if (!($Io !== FALSE)) {
                goto X9;
            }
            $this->certificates = $Io["\x43\145\162\x74\151\146\x69\x63\141\x74\145\163"];
            $this->validators[] = array("\106\x75\x6e\x63\164\151\157\156" => array("\125\x74\151\154\151\164\151\x65\x73", "\x76\x61\154\x69\x64\141\x74\x65\123\x69\147\156\x61\x74\165\162\145"), "\x44\141\x74\141" => $Io);
            X9:
        } catch (Exception $pt) {
        }
        $this->sessionIndexes = array();
        if (!$ER->hasAttribute("\116\x6f\164\117\156\x4f\162\x41\x66\164\x65\x72")) {
            goto Nf;
        }
        $this->notOnOrAfter = SAMLSPUtilities::xsDateTimeToTimestamp($ER->getAttribute("\116\157\x74\117\x6e\x4f\x72\101\146\x74\145\x72"));
        Nf:
        $uO = SAMLSPUtilities::xpQuery($ER, "\x2e\57\x73\141\155\x6c\x5f\x61\163\x73\x65\x72\x74\x69\157\156\72\x4e\x61\x6d\145\x49\104\40\174\40\56\57\x73\x61\x6d\x6c\137\141\163\x73\145\162\164\x69\157\156\72\105\156\143\x72\x79\160\164\145\x64\x49\x44\x2f\170\x65\x6e\x63\x3a\105\x6e\143\162\171\x70\x74\145\x64\104\141\164\x61");
        if (empty($uO)) {
            goto Qg;
        }
        if (count($uO) > 1) {
            goto gJ;
        }
        goto Lc;
        Qg:
        throw new Exception("\x4d\151\x73\x73\x69\156\147\40\x3c\x73\141\155\x6c\72\x4e\x61\155\145\111\x44\76\x20\x6f\162\x20\74\163\141\x6d\154\72\105\156\x63\x72\x79\x70\164\x65\144\111\104\x3e\40\x69\156\x20\x3c\163\x61\155\x6c\x70\x3a\114\157\x67\x6f\x75\164\122\x65\161\165\x65\163\164\x3e\56");
        goto Lc;
        gJ:
        throw new Exception("\x4d\157\x72\x65\40\x74\x68\141\156\x20\157\156\x65\40\74\x73\x61\x6d\154\72\x4e\141\155\145\111\x44\x3e\40\x6f\x72\40\74\x73\141\155\x6c\x3a\x45\x6e\x63\x72\171\160\164\x65\144\x44\x3e\x20\151\156\x20\74\163\141\x6d\x6c\160\x3a\x4c\x6f\x67\157\165\164\x52\145\x71\165\145\163\x74\76\56");
        Lc:
        $uO = $uO[0];
        if ($uO->localName === "\x45\156\x63\x72\171\160\x74\145\144\x44\x61\164\141") {
            goto t_;
        }
        $this->nameId = SAMLSPUtilities::parseNameId($uO);
        goto wQ;
        t_:
        $this->encryptedNameId = $uO;
        wQ:
        $WU = SAMLSPUtilities::xpQuery($ER, "\56\57\x73\x61\x6d\x6c\137\x70\162\157\164\157\x63\x6f\x6c\x3a\x53\x65\163\163\x69\157\x6e\111\x6e\x64\145\170");
        foreach ($WU as $L3) {
            $this->sessionIndexes[] = trim($L3->textContent);
            q_:
        }
        MY:
    }
    public function getNotOnOrAfter()
    {
        return $this->notOnOrAfter;
    }
    public function setNotOnOrAfter($H0)
    {
        $this->notOnOrAfter = $H0;
    }
    public function isNameIdEncrypted()
    {
        if (!($this->encryptedNameId !== NULL)) {
            goto ng;
        }
        return TRUE;
        ng:
        return FALSE;
    }
    public function encryptNameId(XMLSecurityKey $Xx)
    {
        $X_ = new DOMDocument();
        $MO = $X_->createElement("\162\157\157\164");
        $X_->appendChild($MO);
        SAML2_Utils::addNameId($MO, $this->nameId);
        $uO = $MO->firstChild;
        SAML2_Utils::getContainer()->debugMessage($uO, "\x65\x6e\143\162\171\x70\x74");
        $J0 = new XMLSecEnc();
        $J0->setNode($uO);
        $J0->type = XMLSecEnc::Element;
        $g3 = new XMLSecurityKey(XMLSecurityKey::AES128_CBC);
        $g3->generateSessionKey();
        $J0->encryptKey($Xx, $g3);
        $this->encryptedNameId = $J0->encryptNode($g3);
        $this->nameId = NULL;
    }
    public function decryptNameId(XMLSecurityKey $Xx, array $TJ = array())
    {
        if (!($this->encryptedNameId === NULL)) {
            goto os;
        }
        return;
        os:
        $uO = SAML2_Utils::decryptElement($this->encryptedNameId, $Xx, $TJ);
        SAML2_Utils::getContainer()->debugMessage($uO, "\x64\x65\x63\162\171\x70\x74");
        $this->nameId = SAML2_Utils::parseNameId($uO);
        $this->encryptedNameId = NULL;
    }
    public function getNameId()
    {
        if (!($this->encryptedNameId !== NULL)) {
            goto eX;
        }
        throw new Exception("\x41\164\x74\x65\155\x70\164\145\144\40\x74\157\40\x72\x65\164\x72\x69\145\166\x65\40\145\x6e\x63\x72\x79\160\x74\145\x64\40\116\x61\x6d\145\x49\x44\40\167\x69\x74\150\x6f\165\164\x20\144\x65\143\x72\171\x70\164\x69\x6e\147\40\x69\x74\x20\146\151\162\x73\164\x2e");
        eX:
        return $this->nameId;
    }
    public function setNameId($uO)
    {
        $this->nameId = $uO;
    }
    public function getSessionIndexes()
    {
        return $this->sessionIndexes;
    }
    public function setSessionIndexes(array $WU)
    {
        $this->sessionIndexes = $WU;
    }
    public function getSessionIndex()
    {
        if (!empty($this->sessionIndexes)) {
            goto Ff;
        }
        return NULL;
        Ff:
        return $this->sessionIndexes[0];
    }
    public function setSessionIndex($L3)
    {
        if (is_null($L3)) {
            goto cN;
        }
        $this->sessionIndexes = array($L3);
        goto jJ;
        cN:
        $this->sessionIndexes = array();
        jJ:
    }
    public function getId()
    {
        return $this->id;
    }
    public function setId($QY)
    {
        $this->id = $QY;
    }
    public function getIssueInstant()
    {
        return $this->issueInstant;
    }
    public function setIssueInstant($iv)
    {
        $this->issueInstant = $iv;
    }
    public function getDestination()
    {
        return $this->destination;
    }
    public function setDestination($qT)
    {
        $this->destination = $qT;
    }
    public function getIssuer()
    {
        return $this->issuer;
    }
    public function setIssuer($CL)
    {
        $this->issuer = $CL;
    }
}
