<?php
/**
 * This file is a part of the miniorange-saml-20-single-sign-on plugin.
 *
 * @link https://plugins.miniorange.com/
 * @author miniOrange
 * @package miniorange-saml-20-single-sign-on
 */


class IDPMetadataReader
{
    private $identityProviders;
    private $serviceProviders;
    public function __construct(DOMNode $ER = NULL)
    {
        $this->identityProviders = array();
        $this->serviceProviders = array();
        $jC = SAMLSPUtilities::xpQuery($ER, "\x2e\57\163\x61\x6d\154\137\155\145\x74\141\144\x61\x74\x61\72\105\156\164\x69\164\x69\145\x73\x44\145\163\143\162\151\x70\164\157\162");
        if (!empty($jC)) {
            goto jt;
        }
        $Mp = SAMLSPUtilities::xpQuery($ER, "\x2e\x2f\x73\141\x6d\154\x5f\155\145\164\141\144\x61\164\141\x3a\105\x6e\164\151\164\171\104\145\x73\x63\x72\x69\x70\x74\x6f\162");
        goto Vp;
        jt:
        $Mp = SAMLSPUtilities::xpQuery($jC[0], "\56\x2f\x73\x61\x6d\154\x5f\x6d\x65\164\141\144\141\164\141\72\x45\156\164\x69\164\x79\x44\x65\163\143\162\151\160\x74\157\x72");
        Vp:
        foreach ($Mp as $eQ) {
            $ll = SAMLSPUtilities::xpQuery($eQ, "\56\57\163\141\155\x6c\x5f\155\145\x74\x61\x64\x61\164\x61\72\x49\x44\x50\x53\123\x4f\x44\145\163\143\162\151\x70\x74\x6f\162");
            if (empty($ll)) {
                goto td;
            }
            array_push($this->identityProviders, new IdentityProviders($eQ));
            td:
            Bz:
        }
        nh:
    }
    public function getIdentityProviders()
    {
        return $this->identityProviders;
    }
    public function getServiceProviders()
    {
        return $this->serviceProviders;
    }
}
class IdentityProviders
{
    private $idpName;
    private $entityID;
    private $loginDetails;
    private $logoutDetails;
    private $signingCertificate;
    private $encryptionCertificate;
    private $signedRequest;
    public function __construct(DOMElement $ER = NULL)
    {
        $this->idpName = '';
        $this->loginDetails = array();
        $this->logoutDetails = array();
        $this->signingCertificate = array();
        $this->encryptionCertificate = array();
        if (!$ER->hasAttribute("\x65\156\x74\x69\x74\x79\111\x44")) {
            goto I7;
        }
        $this->entityID = $ER->getAttribute("\145\156\164\151\164\171\x49\x44");
        I7:
        if (!$ER->hasAttribute("\127\x61\x6e\164\x41\165\x74\x68\156\x52\x65\x71\165\x65\163\x74\x73\x53\x69\147\156\x65\x64")) {
            goto G5;
        }
        $this->signedRequest = $ER->getAttribute("\x57\141\156\x74\101\x75\164\150\x6e\x52\x65\161\x75\145\x73\164\x73\123\151\147\x6e\x65\x64");
        G5:
        $ll = SAMLSPUtilities::xpQuery($ER, "\56\x2f\x73\x61\x6d\154\x5f\155\x65\164\141\144\x61\164\141\x3a\111\x44\x50\x53\x53\x4f\104\145\x73\143\x72\x69\160\164\x6f\x72");
        if (count($ll) > 1) {
            goto FU;
        }
        if (empty($ll)) {
            goto xT;
        }
        goto zT;
        FU:
        throw new Exception("\x4d\157\162\x65\x20\x74\150\x61\156\x20\x6f\x6e\x65\x20\x3c\x49\104\120\123\123\117\104\145\x73\143\x72\x69\160\164\x6f\162\x3e\40\x69\x6e\40\74\105\156\164\x69\164\x79\x44\x65\x73\x63\x72\151\x70\164\x6f\162\76\x2e");
        goto zT;
        xT:
        throw new Exception("\x4d\151\x73\163\x69\x6e\147\40\x72\145\161\165\x69\x72\145\144\x20\74\111\104\120\123\123\x4f\104\145\163\143\x72\151\160\164\157\x72\x3e\x20\x69\156\x20\x3c\x45\156\164\151\x74\171\x44\145\x73\143\162\151\160\164\157\162\x3e\x2e");
        zT:
        $NO = $ll[0];
        $VX = SAMLSPUtilities::xpQuery($ER, "\x2e\57\163\141\155\x6c\137\x6d\x65\x74\141\x64\x61\x74\141\x3a\105\170\164\145\x6e\x73\151\x6f\156\x73");
        if (!$VX) {
            goto fu;
        }
        $this->parseInfo($NO);
        fu:
        $this->parseSSOService($NO);
        $this->parseSLOService($NO);
        $this->parsex509Certificate($NO);
    }
    private function parseInfo($ER)
    {
        $G0 = SAMLSPUtilities::xpQuery($ER, "\56\x2f\155\144\165\x69\x3a\125\x49\x49\156\x66\157\x2f\155\x64\165\x69\72\x44\151\163\x70\154\x61\x79\x4e\x61\x6d\145");
        foreach ($G0 as $SC) {
            if (!($SC->hasAttribute("\x78\x6d\154\x3a\x6c\141\156\x67") && $SC->getAttribute("\170\155\x6c\x3a\154\141\x6e\x67") == "\x65\156")) {
                goto Fu;
            }
            $this->idpName = $SC->textContent;
            Fu:
            G_:
        }
        RN:
    }
    private function parseSSOService($ER)
    {
        $f3 = SAMLSPUtilities::xpQuery($ER, "\x2e\x2f\x73\141\155\x6c\137\155\145\x74\x61\x64\x61\164\141\72\123\x69\x6e\147\x6c\145\x53\151\x67\x6e\117\156\x53\145\x72\x76\x69\x63\145");
        foreach ($f3 as $St) {
            $KO = str_replace("\x75\x72\156\72\157\141\x73\151\x73\72\156\x61\x6d\x65\163\x3a\164\x63\72\123\101\115\114\x3a\62\x2e\x30\72\x62\x69\x6e\144\151\156\147\x73\72", '', $St->getAttribute("\102\x69\156\144\x69\156\x67"));
            $this->loginDetails = array_merge($this->loginDetails, array($KO => $St->getAttribute("\114\x6f\143\141\x74\x69\157\x6e")));
            Fv:
        }
        D8:
    }
    private function parseSLOService($ER)
    {
        $pf = SAMLSPUtilities::xpQuery($ER, "\56\x2f\x73\x61\x6d\154\137\155\x65\x74\x61\x64\141\x74\141\72\123\x69\156\x67\x6c\x65\114\157\x67\x6f\x75\164\123\145\162\166\x69\x63\x65");
        if (!empty($pf)) {
            goto wC;
        }
        $this->logoutDetails = array("\x48\x54\x54\120\x2d\122\145\144\151\x72\145\x63\x74" => '');
        goto co;
        wC:
        foreach ($pf as $Dk) {
            $KO = str_replace("\165\x72\156\72\157\x61\163\151\163\72\156\141\x6d\x65\163\x3a\164\143\72\123\101\x4d\114\72\62\56\60\x3a\x62\151\156\144\151\x6e\147\163\72", '', $Dk->getAttribute("\x42\151\x6e\x64\151\156\x67"));
            $this->logoutDetails = array_merge($this->logoutDetails, array($KO => $Dk->getAttribute("\114\x6f\x63\141\164\151\157\x6e")));
            GB:
        }
        Qw:
        co:
    }
    private function parsex509Certificate($ER)
    {
        foreach (SAMLSPUtilities::xpQuery($ER, "\x2e\x2f\x73\141\x6d\x6c\137\x6d\x65\x74\141\x64\x61\164\141\x3a\x4b\145\171\104\145\163\143\162\151\160\164\157\162") as $vM) {
            if ($vM->hasAttribute("\165\x73\145")) {
                goto TL;
            }
            $this->parseSigningCertificate($vM);
            goto nW;
            TL:
            if ($vM->getAttribute("\165\x73\x65") == "\x65\156\x63\162\171\160\x74\x69\x6f\x6e") {
                goto I1;
            }
            $this->parseSigningCertificate($vM);
            goto PJ;
            I1:
            $this->parseEncryptionCertificate($vM);
            PJ:
            nW:
            Ig:
        }
        FQ:
    }
    private function parseSigningCertificate($ER)
    {
        $gK = SAMLSPUtilities::xpQuery($ER, "\56\57\x64\x73\x3a\113\145\x79\111\x6e\146\x6f\x2f\144\163\72\130\x35\60\x39\104\x61\x74\141\57\x64\163\72\x58\65\60\71\x43\145\162\164\x69\146\x69\143\x61\164\145");
        $XI = trim($gK[0]->textContent);
        $XI = str_replace(array("\xd", "\xa", "\x9", "\x20"), '', $XI);
        if (empty($gK)) {
            goto zK;
        }
        array_push($this->signingCertificate, SAMLSPUtilities::sanitize_certificate($XI));
        zK:
    }
    private function parseEncryptionCertificate($ER)
    {
        $gK = SAMLSPUtilities::xpQuery($ER, "\56\57\144\163\72\113\145\171\111\x6e\x66\x6f\57\144\x73\x3a\130\65\x30\71\x44\141\164\x61\x2f\144\163\x3a\x58\65\x30\x39\x43\145\162\164\x69\x66\x69\x63\x61\164\x65");
        $XI = trim($gK[0]->textContent);
        $XI = str_replace(array("\xd", "\xa", "\11", "\x20"), '', $XI);
        if (empty($gK)) {
            goto pG;
        }
        array_push($this->encryptionCertificate, $XI);
        pG:
    }
    public function getIdpName()
    {
        return $this->idpName;
    }
    public function getEntityID()
    {
        return $this->entityID;
    }
    public function getLoginURL($KO)
    {
        return $this->loginDetails[$KO];
    }
    public function getLogoutURL($KO)
    {
        return $this->logoutDetails[$KO];
    }
    public function getLoginDetails()
    {
        return $this->loginDetails;
    }
    public function getLogoutDetails()
    {
        return $this->logoutDetails;
    }
    public function getSigningCertificate()
    {
        return $this->signingCertificate;
    }
    public function getEncryptionCertificate()
    {
        return $this->encryptionCertificate[0];
    }
    public function isRequestSigned()
    {
        return $this->signedRequest;
    }
}
class ServiceProviders
{
}
